while 1
    ImageFilename = uigetfile(["*.bmp"]);
    
    if(length(ImageFilename) == 0)
        break
    end
    
    CurrentImage = ReadImage(ImageFilename);
    
    CurrentImage = SegmentByThreshold(CurrentImage, 150);
    
    [ImageRows, ImageCols] = size(CurrentImage);
    PixelData_Array_Length = ImageRows * (ImageCols/8)

    PixelData = uint8(zeros(ImageRows, ImageCols/8));

    for row = 1:ImageRows
        bit_position = 8;
        column_byte = 1;
        for column = 1:ImageCols
            if (CurrentImage(row,column) == %T) then
                PixelData(row, column_byte) = bitset(PixelData(row, column_byte), bit_position, 1);
            else
                PixelData(row, column_byte) = bitset(PixelData(row, column_byte), bit_position, 0);
            end
            bit_position = bit_position - 1;
            if bit_position == 0 then
                bit_position = 8;
                column_byte = column_byte + 1;
            end
        end
    end
    
    PixelData = matrix(PixelData', 1, PixelData_Array_Length);
        
    [path, fname, extension] = fileparts(ImageFilename);
    
    if(PixelData_Array_Length == 90) then
        printf('code unsigned char LCD_%s[DIGIT_PIXDATA_ARRAY_LEN] = {', fname);
          
    elseif(PixelData_Array_Length == 120) then
        printf('code unsigned char LCD_%s[UNIT_PIXDATA_ARRAY_LEN] = {', fname);
    end
          
    for pixel_byte = 1:PixelData_Array_Length
        printf('0x%02X',  PixelData(pixel_byte))
        if(pixel_byte ~= PixelData_Array_Length) then
            printf(', ')
        else
            printf('};\n\n')
        end
    end

end

printf('\n\n-------------------Extern declarations------------------\n\n')

while 1
    ImageFilename = uigetfile(["*.bmp"]);
    
    if(length(ImageFilename) == 0)
        break
    end
    
    CurrentImage = ReadImage(ImageFilename);
    
    [ImageRows, ImageCols] = size(CurrentImage);
    PixelData_Array_Length = ImageRows * (ImageCols/8)
    
    [path, fname, extension] = fileparts(ImageFilename);
    
    if(PixelData_Array_Length == 90) then
        printf('extern code unsigned char LCD_%s[DIGIT_PIXDATA_ARRAY_LEN];\n', fname);
          
    elseif(PixelData_Array_Length == 120) then
        printf('extern code unsigned char LCD_%s[UNIT_PIXDATA_ARRAY_LEN];\n', fname);
    end
end
